// Generated by CoffeeScript 2.7.0
(function() {
  var Breadcrumbs;

  Breadcrumbs = (function() {
    class Breadcrumbs {
      constructor($window, slashdb) {
        var bName, bPath, defaultLimit, nullPlaceholder, nullQueryParam, params, path, queriesPath, search, segments;
        this.breadcrumbs = [];
        path = $window.location.pathname.replace(/\.html+$/, '/');
        path = path.replace(/\/$/, '');
        params = new URLSearchParams($window.location.search);
        nullPlaceholder = slashdb.settings['html_sdb.datadiscovery.null_display_str'] || '<null>';
        nullQueryParam = slashdb.settings['datadiscovery.null_str'] || '<null>';
        this.emptyPlaceholder = slashdb.settings['html_sdb.datadiscovery.empty_display_str'] || '';
        if (!params.has('limit')) {
          defaultLimit = parseInt(slashdb.settings.html_limit) || 29;
          params.set('limit', defaultLimit);
        }
        queriesPath = localStorage.getItem('breadcrumbsQueriesPath');
        if (!queriesPath) {
          queriesPath = '/query';
        }
        if (path === '/querydef' && !$window.document.querySelector('.error_message')) {
          localStorage.setItem('breadcrumbsQueriesPath', '/querydef');
        }
        if (path === '/query') {
          localStorage.setItem('breadcrumbsQueriesPath', '/query');
        }
        while (path) {
          segments = path.split('/');
          bName = decodeURIComponent(segments.pop());
          bPath = path;
          bName = (function() {
            switch (bName) {
              case 'dbdef':
                return 'Database Definitions';
              case 'userdef':
                return 'User Definitions';
              case 'querydef':
                return 'Query Definitions';
              case 'query':
                return 'Queries';
              //when 'querystudio' then 'Query Studio'
              case 'license':
                return 'License';
              case '':
                return this.emptyPlaceholder;
              case nullQueryParam:
                return nullPlaceholder;
              default:
                return bName;
            }
          }).call(this);
          // On segment 'querystudio' we want to redirect to queries list instead of empty query studio form
          if (bName === 'querystudio') {
            bName = 'Queries';
            bPath = queriesPath;
          }
          if (segments.length < 3) {
            search = $window.location.search;
          } else {
            search = '?' + params.toString();
          }
          if (bName === '') {
            bPath += '/';
          }
          bPath = bPath + search;
          this.breadcrumbs.push({
            name: bName,
            path: bPath
          });
          path = segments.join('/');
        }
        this.breadcrumbs.push({
          name: 'SlashDB',
          path: '/'
        });
        this.breadcrumbs = this.breadcrumbs.reverse();
        return null;
      }

    };

    Breadcrumbs.$inject = ['$window', 'slashDB'];

    return Breadcrumbs;

  }).call(this);

  angular.module('sdbgui').component('breadcrumbs', {
    templateUrl: '/static/components/sdbgui-breadcrumbs/breadcrumbs.html',
    controller: Breadcrumbs
  });

}).call(this);
