angular.module('sdbgui')
    .controller('LicenseController', ['slashDB', '$window', 'sessionControlService',
        function (slashdb, $window, sessionControlService) {
        var ctrl = this;

        this.licFile = null;
        this.licLoaded = false;
        this.alert = '';

        this.uploadLicense = function () {
            this.alert = '';
            slashdb.uploadLicense(ctrl.licFile)
                .then(function (response) {
                    $window.location.reload();

                    // refresh slashDB.settings
                    slashdb.setupSettings();
                })
                .catch(function (response) {
                    ctrl.alert = response.headers('Warning');
                })
                .finally(() => {
                    sessionControlService.onSessionLost(() =>
                        ctrl.alert = sessionControlService.expiredMsg
                    )
                    
                    sessionControlService.onSessionRestore(() => {
                        // refresh user
                        slashdb.setupSettings();
                        ctrl.alert = '';
                    })
                });
        };
    }]);