'use strict';

angular.module('sdbgui')
    .component('modalConfigHeader', {
        template: ' \
        <div class="modal-header"> \
            <h3 class="modal-title">\
                {{ $ctrl.title }}\
                <i class="fas fa-times pull-right pointer-cursor" ng-click="$ctrl.onClose()"></i> \
            </h3> \
        </div>',
        bindings: {
            title: '@',
            onClose: '&'
        }
    })
    .component('modalConfigAlert', {
        template: ' \
        <div class="alert error-box" ng-class="$ctrl.alertClass" role="alert" ng-cloak ng-show="$ctrl.modalAlert.length > 0"> \
            <a ng-href="#" class="close" ng-click="$ctrl.onCloseAlert()">&times;</a> \
            <span>{{ $ctrl.modalAlert }}</span> \
        </div>',
        bindings: {
            modalAlert: '<',
            onCloseAlert: '&',
            alertClass: '<',
        },
        controller: function () {
            let ctrl = this;
            ctrl.$onInit = () => {
                if (!ctrl.alertClass) {
                    ctrl.alertClass = 'alert-danger';
                }
            }
        },
    })
    .component('modalConfigFooter', {
        template: ' \
        <div class="modal-footer"> \
            <button class="btn btn-danger pull-left" type="button" \
                    ng-click="$ctrl.confirmDeleteVisible = true" ng-disabled="$ctrl.savingInProgress"\
                    ng-cloak ng-show="$ctrl.isDeleteVisible">Delete</button> \
            <span class="confirm-delete pull-left" ng-show="$ctrl.confirmDeleteVisible"> \
                Are you sure? \
                <input type="button" value="Yes" class="btn btn-link" ng-click="$ctrl.onDelete()" ng-disabled="$ctrl.savingInProgress" /> \
                <input type="button" value="No" class="btn btn-link" ng-click="$ctrl.confirmDeleteVisible = false" ng-disabled="$ctrl.savingInProgress" /> \
            </span> \
            <span class="blinker glyphicon glyphicon-ok text-success fading" ng-class="{in: $ctrl.isOkVisible}"></span> \
            <button class="btn btn-success" type="submit" ng-click="$ctrl.onSave()" ng-show="$ctrl.isEditable" ng-disabled="$ctrl.savingInProgress">Save</button> \
            <button class="btn btn-default" type="button" ng-click="$ctrl.onClose()">Close</button> \
        </div>',
        controller: function () {
            var ctrl = this;
            ctrl.confirmDeleteVisible = false;
        },
        bindings: {
            isDeleteVisible: '<',
            isOkVisible: '<',
            isEditable: '<',
            savingInProgress: '<',
            onDelete: '&',
            onSave: '&',
            onClose: '&'
        }
    });
