angular.module('sdbgui')
    .controller('NavbarController', ['$scope', '$window', '$uibModal', 'slashDB', function ($scope, $window, $uibModal, slashdb) {
        var ctrl = this;
        ctrl.popoverTemplateUrl = '/static/components/sdbgui-navbar-popover.template.html';
        ctrl.openUserSettings = function (addNewBtnMsg) {
            addNewBtnMsg = addNewBtnMsg == null ? '' : addNewBtnMsg;
            let uiModalInstance = $uibModal.open({
                templateUrl: '/static/components/sdbgui-userconfigs/sdbgui-userconfigs-modal.template.html',
                size: 'lg',
                controller: 'UserConfigModalCtrl',
                resolve: {
                    configId: function () {
                        return slashdb.settings.user;
                    },
                    editable: function () {
                        return true;
                    },
                    addNewBtnMsg: function() {
                        return addNewBtnMsg;
                    }
                }
            });

            uiModalInstance.result
                .catch(() => {}) // silence warning
        };

        ctrl.loggedIn = () => {
            return !['public', null].includes(slashdb.settings.user);
        }

        ctrl.getUser = () => {
            return slashdb.settings.user;
        }

        ctrl.onLogout = () => {
            $window.localStorage.removeItem('sdb.loggedIn');
            $window.localStorage.removeItem('sdb.sessionLost');
        }

        $scope.$on('open-user-settings-modal', function (e, msg) {
            ctrl.openUserSettings(msg);
        });
    }]);