(function () {
    'use strict';

    // Usage: <notificator></notificator>
    // 
    // Creates: a notification area for errors and warnings
    // 

    var notificatorDir = '/static/components/sdbgui-notificator/';

    angular.module('sdbgui')
        .component('notificator', {
            templateUrl: notificatorDir + 'sdbgui-notificator.template.html',
            controller: NotificatorController
        });

    NotificatorController.$inject = ['$element', 'slashDB'];

    function NotificatorController($element, slashDB) {
        var $ctrl = this;
        $ctrl.sdbSettings = slashDB.settings;

        $ctrl.getBtnClass = function () {
            var war = $ctrl.sdbSettings.configure_warnings,
                err = $ctrl.sdbSettings.configure_errors;

            if (err != null && err.length) {
                return 'btn-danger';

            } else if (war != null && war.length) {
                return 'btn-warning';
            }
            return 'btn-default';
        };
    }
})();