// Generated by CoffeeScript 2.7.0
(function() {
  var indexOf = [].indexOf;

  angular.module('sdbgui').factory('QueryExecService', [
    '$rootScope',
    '$location',
    'slashDB',
    function($rootScope,
    $location,
    slashdb) {
      var QueryExecService;
      return new (QueryExecService = class QueryExecService {
        constructor() {
          this.queryBasePath = $location.protocol() + '://' + $location.host();
          if ($location.port && $location.port !== 80) {
            this.queryBasePath = this.queryBasePath + ':' + $location.port();
          }
          this.queryBasePath = this.queryBasePath + '/query';
          this.loadMoreVisible = false;
          this.nullPlaceHolder = '<SDB_NULL>';
          this.resetQueryOutput();
        }

        resetQueryOutput() {
          return this.queryOutput = {
            columnNames: [],
            data: []
          };
        }

        getExecPath(queryId,
    queryParameters,
    limit,
    offset = 0,
    count,
    format,
    distinct = false,
    transpose = false,
    stream = false,
    nullStr = false,
    order_by = null) {
          var encodedParamValue,
    key,
    paramName,
    paramValue,
    qs,
    qs_url_substitution,
    ref,
    url,
    value;
          url = '/' + queryId;
          qs_url_substitution = {};
          for (paramName in queryParameters) {
            paramValue = queryParameters[paramName];
            if (paramValue) {
              ref = slashdb.settings.reversed_url_substitution;
              for (key in ref) {
                value = ref[key];
                if (key === '.' && (paramValue !== '.' && paramValue !== '..')) {
                  // skip dots, because they special
                  continue;
                } else if (indexOf.call(paramValue,
    key) >= 0) {
                  paramValue = paramValue.replace(new RegExp(key,
    'g'),
    value);
                  qs_url_substitution[key] = value;
                }
              }
            } else {
              paramValue = '';
            }
            encodedParamValue = encodeURIComponent(paramValue);
            url = `${url}/${paramName}/${encodedParamValue}`;
          }
          qs = [];
          if ((limit != null) && limit > -1) {
            qs.push(`limit=${limit}`);
          }
          if (offset > 0) {
            qs.push(`offset=${offset}`);
          }
          if (count) {
            qs.push("count");
          }
          if (distinct) {
            qs.push("distinct");
          }
          if (transpose) {
            qs.push("transpose");
          }
          if (stream) {
            qs.push("stream=true");
          }
          if (nullStr) {
            qs.push(`nullStr=${this.nullPlaceHolder}`);
          }
          if (order_by) {
            qs.push(`sort=${order_by}`);
          }
          if (qs_url_substitution) {
            for (key in qs_url_substitution) {
              value = qs_url_substitution[key];
              qs.push(`${value}=${key}`);
            }
          }
          qs = qs.join('&');
          if (qs) {
            qs = `?${qs}`;
          }
          url = url + '.' + format + qs;
          return url;
        }

        executeQuery(queryId,
    httpMethod,
    data,
    params,
    headers) {
          var httpSettings,
    url;
          this.resetQueryOutput();
          httpSettings = {
            params: params,
            headers: headers
          };
          if (httpMethod === 'GET' || httpMethod === 'DELETE') {
            // when making GET requests query parameters are passed in url
            url = this.getExecPath(queryId,
    data,
    null,
    null,
    null,
    'json');
            data = null;
          } else {
            url = '/' + queryId + '.json';
          }
          return slashdb.executeQuery(url,
    httpMethod,
    data,
    httpSettings).then((response) => {
            if (response.data.length > 0) {
              this.queryOutput.columnNames = JSON.parse(response.headers('columns'));
              this.queryOutput.numericColumns = JSON.parse(response.headers('numeric_columns'));
              this.queryOutput.data = response.data;
              this.loadMoreVisible = true;
            }
            $rootScope.$broadcast('queryExecuted',
    {
              httpResponse: response
            });
          }).catch((response) => {
            this.queryOutput.columnNames = [];
            this.queryOutput.data = [];
            $rootScope.$broadcast('queryExecuted',
    {
              httpResponse: response
            });
          });
        }

      })();
    }
  ]);

}).call(this);
